--the statistics including actual rows number and size per table including lob segments
--@"E:\DVD\ilstore03\CurrentWork\CreateMasterDB\Statistics\ForCustomer\SchemasStatistics_AS_SYSTEM_UCMDB10.sql" CMDB10
CLEAR BREAKS
CLEAR COMPUTE
SET ECHO OFF NEWP 0 SPA 0 PAGES 0 FEED OFF HEAD OFF TRIMS ON TAB OFF
set line 1000
set longchunksize 500
set pagesize 0
set heading off
set feedback off
set serveroutput off
set SHOW off
set VERIFY off
set timing off
set time off

COLUMN spool_file_name NEW_VALUE spool_file_name NOPRINT

--spool %userprofile%\Desktop\UCMDB_SchemaStatistics_Partion_Output.txt
SELECT '%userprofile%\Desktop\''&1''__SchemaStatistics_Output_' || TO_CHAR(SYSDATE , 'DDMMYYYY_hh24miss') || '_' || sys_context('USERENV', 'INSTANCE_NAME') || '.txt' spool_file_name
FROM DUAL
/

SPOOL &spool_file_name 

----General info ----
select 'SYSDATE;INSTANCE_NUMBER;INSTANCE_NAME;HOST_NAME;VERSION;STATUS;BLOCKED;STARTUP_TIME' from dual
/
select to_char(sysdate, 'DD-MON-YYYY hh24:mi') || ';' ||INSTANCE_NUMBER || ';' || INSTANCE_NAME || ';' ||  
	HOST_NAME || ';' || VERSION || ';' || STATUS || ';' || BLOCKED || ';' || trim(to_char(STARTUP_TIME, 'DD-MON-YYYY hh24:mi'))
from gv$instance
/

select chr(10) || 'INST_ID;DBID;NAME;DB_UNIQUE_NAME;CREATED;LOG_MODE;OPEN_MODE;PLATFORM_NAME;PLATFORM_ID;GUARD_STATUS;CURRENT_SCN;end@'
from dual
/
select INST_ID || ';' || DBID || ';' || NAME || ';' || DB_UNIQUE_NAME || ';' || trim(to_char(CREATED, 'DD-MON-YYYY hh24:mi')) || ';' || LOG_MODE || ';' 
	|| OPEN_MODE || ';' || PLATFORM_NAME || ';' || PLATFORM_ID || ';' || GUARD_STATUS || ';' || CURRENT_SCN
from gv$database
/

select chr(10) || 'nls_param_name;db_value;inst_value;end@'
from dual
/
select d.parameter || ';' || d.value || ';' || i.value
from NLS_DATABASE_PARAMETERS d left outer join NLS_INSTANCE_PARAMETERS i on (d.parameter=i.parameter)
/

select chr(10) || 'TABLESPACE;Full,MB;Free,MB;Used,MB;Used,%;end@' from dual
/
select TABLESPACE || ';' || "Full, MB" || ';' || "Free, MB" || ';' || "Used, MB" || ';' || "Used,%"
from (
	select a.tablespace_name TABLESPACE,  a.full as "Full, MB", b.free "Free, MB", a.full-b.free "Used, MB", round(100*(a.full-b.free)/a.full,2) "Used,%"
	from
		(select tablespace_name, sum(bytes/1024/1024) full
	 	from dba_data_files
	 	group by tablespace_name) a 
	  left outer join
	 	(select tablespace_name,sum(bytes/1024/1024) free
	 	from dba_free_space
	 	group by tablespace_name) b
	  on a.tablespace_name = b.tablespace_name
	union 
	select a.tablespace_name TABLESPACE, d.mb_total "Full, MB",
	     d.mb_total - sum(a.used_blocks * d.block_size)/1024/1024 "Free, MB",
	     sum (a.used_blocks * d.block_size)/1024/1024 "Used, MB",
	     round(100*(sum(a.used_blocks * d.block_size)/1024/1024)/d.mb_total,2) "Used,%"
	from     v$sort_segment a,
	     (
	     select   b.name, c.block_size, sum (c.bytes) / 1024 / 1024 mb_total
	     from     v$tablespace b, v$tempfile c
	     where    b.ts#= c.ts#
	     group by b.name, c.block_size
	     ) d
	where    a.tablespace_name = d.name
	group by a.tablespace_name, d.mb_total
	order by TABLESPACE
)
/

select chr(10) || 'r.user_id;u.username;session_id;error_msg;sql_text;status;timeout;start_time;suspend_time;resume_time;end@' from dual
/
SELECT r.user_id || ';' || u.username || ';' || session_id || ';' || error_msg || ';' || sql_text || ';' || status || ';' || timeout || ';' || start_time || ';' || suspend_time || ';' || resume_time
FROM dba_resumable r inner join dba_users u 
	on (r.user_id=u.user_id)
order by r.user_id,session_id
/

select chr(10) || 'TABLESPACE_NAME;BLOCK_SIZE;INITIAL_EXTENT;NEXT_EXTENT;MIN_EXTENTS;MAX_EXTENTS;PCT_INCREASE;MIN_EXTLEN;STATUS;CONTENTS;LOGGING;FORCE_LOGGING;EXTENT_MANAGEMENT;ALLOCATION_TYPE;PLUGGED_IN;SEGMENT_SPACE_MANAGEMENT;DEF_TAB_COMPRESSION;RETENTION;BIGFILE;end@' from dual
/
select TABLESPACE_NAME || ';' || BLOCK_SIZE || ';' || INITIAL_EXTENT || ';' || NEXT_EXTENT || ';' || MIN_EXTENTS || ';' || MAX_EXTENTS || ';' || PCT_INCREASE || ';' || MIN_EXTLEN || ';' || STATUS || ';' || CONTENTS || ';' || LOGGING || ';' || FORCE_LOGGING || ';' || EXTENT_MANAGEMENT || ';' || ALLOCATION_TYPE || ';' || PLUGGED_IN || ';' || SEGMENT_SPACE_MANAGEMENT || ';' || DEF_TAB_COMPRESSION || ';' || RETENTION || ';' || BIGFILE
from dba_tablespaces
/

select chr(10) || 'FILE_NAME;FILE_ID;TABLESPACE_NAME;BYTES;BLOCKS;STATUS;RELATIVE_FNO;AUTOEXTENSIBLE;MAXBYTES;MAXBLOCKS;INCREMENT_BY;USER_BYTES;USER_BLOCKS;ONLINE_STATUS;end@' from dual
/
select FILE_NAME || ';' || FILE_ID || ';' || TABLESPACE_NAME || ';' || BYTES || ';' || BLOCKS || ';' || STATUS || ';' || RELATIVE_FNO || ';' || AUTOEXTENSIBLE || ';' || MAXBYTES || ';' || MAXBLOCKS || ';' || INCREMENT_BY || ';' || USER_BYTES || ';' || USER_BLOCKS || ';' || ONLINE_STATUS
from dba_data_files
union all
select FILE_NAME || ';' || FILE_ID || ';' || TABLESPACE_NAME || ';' || BYTES || ';' || BLOCKS || ';' || STATUS || ';' || RELATIVE_FNO || ';' || AUTOEXTENSIBLE || ';' || MAXBYTES || ';' || MAXBLOCKS || ';' || INCREMENT_BY || ';' || USER_BYTES || ';' || USER_BLOCKS || ';' || 'N/A'
from dba_temp_files
/

select chr(10) || 'thread#;DAY;Count#;Min#;Max#;Daily_Avg_Mb;end@' from dual
/
SELECT A.thread# || ';' || A.DAY || ';' || A.Count# || ';' || A.Min# || ';' || A.Max# || ';' || Round(A.Count#*B.AVG#/1024/1024)
FROM
(
SELECT thread#,
   To_Char(First_Time,'YYYY-MM-DD') DAY,
   Count(1) Count#,
   Min(RECID) Min#,
   Max(RECID) Max#
FROM
   v$log_history
GROUP BY thread#,To_Char(First_Time,'YYYY-MM-DD')
) A inner join 
(
SELECT thread#,
   Avg(BYTES) AVG#,
   Count(1) Count#,
   Max(BYTES) Max_Bytes,
   Min(BYTES) Min_Bytes
FROM v$log
GROUP BY thread#
) B
	on a.thread#=b.thread#
ORDER BY A.day,A.thread#
/

select chr(10) || 'thread#;day;00;01;02;03;04;05;06;07;08;09;10;11;12;13;14;15;16;17;18;19;20;21;22;23;Total;end@' from dual
/

select thread# || ';' ||
  to_char(first_time,'YYYY-MM-DD') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'00',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'01',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'02',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'03',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'04',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'05',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'06',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'07',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'08',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'09',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'10',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'11',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'12',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'13',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'14',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'15',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'16',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'17',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'18',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'19',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'20',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'21',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'22',1,0)),'999') || ';' ||
  to_char(sum(decode(substr(to_char(first_time,'HH24'),1,2),'23',1,0)),'999') || ';' || 
  COUNT(*)
from v$log_history
group by thread#, to_char(first_time,'YYYY-MM-DD')
order by to_char(first_time,'YYYY-MM-DD'), thread#
/

select chr(10) || 'instance_name;inst_id;instance_number;member;GROUP#;MEMBERS;MB_Size;ARCHIVED;STATUS;end@' from dual
/
SELECT i.instance_name || ';' || i.inst_id || ';' || i.instance_number || ';' || lf.member || ';' || l.GROUP# || ';' || l.MEMBERS || ';' || l.BYTES/1024/1024 || ';' || l.ARCHIVED || ';' || l.STATUS
FROM gv$instance i full outer join v$log l on (i.thread#=l.thread#)
                full outer join v$logfile lf on (lf.group# = l.group#)
ORDER BY i.inst_id,l.thread#,lf.group#
/

select chr(10) || 'NAME;VALUE;ISDEFAULT;end@'
from dual
/
select NAME || ';' || VALUE || ';' || ISDEFAULT
from v$parameter
where (ISDEFAULT='FALSE') or (name like '%size%')
order by name
/

select chr(10) || 'USERNAME;PROFILE;RESOURCE_NAME;RESOURCE_TYPE;LIMIT;end@'
from dual
/
select u.USERNAME|| ';' ||p.PROFILE|| ';' ||p.RESOURCE_NAME|| ';' ||p.RESOURCE_TYPE|| ';' ||p.LIMIT 
from dba_profiles p inner join dba_users u on (p.profile=u.profile) where username in (upper('&1'))
/

select chr(10) || 'RESOURCE_NAME;CURRENT_UTILIZATION;MAX_UTILIZATION;INITIAL_ALLOCATION;LIMIT_VALUE;end@'
from dual
/
select RESOURCE_NAME || ';' || CURRENT_UTILIZATION || ';' || MAX_UTILIZATION || ';' || INITIAL_ALLOCATION || ';' || LIMIT_VALUE
from v$resource_limit
/

----CMDB (&1) queries ----
select chr(10) || 'OWNER(dba_tables);SEGMENT;TABLE_NAME;INDEX_NAME;NUM_ROWS;BLOCKS;EMPTY_BLOCKS;' || 
	'AVG_SPACE;CHAIN_CNT;AVG_ROW_LEN;AVG_SPACE_FREELIST_BLOCKS;' ||
	'NUM_FREELIST_BLOCKS;SAMPLE_SIZE;LastAnalyzed;CREATED;O.STATUS;end@'
from dual
/
select T.OWNER || ';TABLE;' || TABLE_NAME || ';N/A;' || NUM_ROWS || ';' || BLOCKS || ';' || EMPTY_BLOCKS || ';' || 
	AVG_SPACE || ';' || CHAIN_CNT || ';' || AVG_ROW_LEN || ';' || AVG_SPACE_FREELIST_BLOCKS || ';' || 
	NUM_FREELIST_BLOCKS || ';' || SAMPLE_SIZE || ';' || trim(to_char(last_analyzed, 'DD-MON-YYYY hh24:mi'))
	|| ';' || trim(to_char(O.CREATED, 'DD-MON-YYYY hh24:mi')) || ';' || O.STATUS
from dba_tables t inner join dba_objects o on (t.owner=o.owner and t.table_name=o.object_name and o.object_type='TABLE')
where T.owner=upper('&1') and table_name not like 'BIN$%'
order by T.OWNER, TABLE_NAME
/

select chr(10) || 'OWNER(dba_indexes);SEGMENT;TABLE_NAME;INDEX_NAME;BLEVEL;LEAF_BLOCKS;' || 
	'DISTINCT_KEYS;AVG_LEAF_BLOCKS_PER_KEY;AVG_DATA_BLOCKS_PER_KEY;CLUSTERING_FACTOR;' ||
       	'I.STATUS;NUM_ROWS;SAMPLE_SIZE;LastAnalyzed;CREATED;O.STATUS;end@'
from dual
/
select I.OWNER || ';INDEX;' || TABLE_NAME || ';' || INDEX_NAME || ';' || BLEVEL || ';' || LEAF_BLOCKS || ';' || 
	DISTINCT_KEYS || ';' || AVG_LEAF_BLOCKS_PER_KEY || ';' || AVG_DATA_BLOCKS_PER_KEY || ';' || CLUSTERING_FACTOR || ';' || 
       	I.STATUS || ';' || NUM_ROWS || ';' || SAMPLE_SIZE || ';' || trim(to_char(last_analyzed, 'DD-MON-YYYY hh24:mi'))
       	|| ';' || trim(to_char(O.CREATED, 'DD-MON-YYYY hh24:mi')) || ';' || O.STATUS
from dba_indexes i inner join dba_objects o on (i.owner=o.owner and i.index_name=o.object_name and o.object_type='INDEX')
where i.owner=upper('&1') and (table_name not like 'BIN$%') and index_type<>'LOB'
order by I.OWNER, TABLE_NAME, INDEX_NAME
/

select chr(10) || 'OWNER(dba_tab_columns);TABLE_NAME;COLUMN_NAME;DATA_TYPE;DATA_LENGTH;COLUMN_ID;NULLABLE;NUM_DISTINCT;DENSITY;NUM_NULLS;NUM_BUCKETS;LastAnalyzed;end@'
from dual
/
select owner || ';' || table_name || ';' || column_name || ';' || data_type || ';' || data_length || ';' || column_id || ';' || nullable || ';' || num_distinct || ';' || density || ';' || num_nulls || ';' || num_buckets || ';' || to_char(last_analyzed, 'DD-MON-YYYY hh24:mi')
from dba_tab_columns 
where owner=upper('&1') and table_name not like 'BIN$%'
order by owner, table_name, column_id
/

select chr(10) || 'OWNER(dba_ind_columns);TABLE_NAME;INDEX_OWNER;INDEX_NAME;COLUMN_NAME;COLUMN_POSITION;end@'
from dual
/
select INDEX_OWNER || ';' || TABLE_NAME || ';' || INDEX_OWNER || ';' || INDEX_NAME || ';' || COLUMN_NAME || ';' || COLUMN_POSITION
from dba_ind_columns
where INDEX_OWNER = upper('&1') and table_name not like 'BIN$%'
order by INDEX_OWNER, TABLE_NAME, INDEX_NAME, COLUMN_POSITION
/

select chr(10) || 'OWNER(dba_segments);TABLE_NAME;SEGMENT_NAME;PARTITION_NAME;SEGMENT_TYPE;MB;BLOCKS;STATS_BLOCKS;end@' from dual
/
select F.owner || ';' || F.table_name || ';' || F.segment_name || ';' || F.partition_name || ';' || F.segment_type || ';' || F.mb || ';' || F.blocks || ';' || F.STATS_BLOCKS
from
  (
	 (
		 select S.owner, S.segment_name, S.partition_name, I.table_name, S.segment_type, round(S.bytes/1024/1204, 1) mb, S.blocks, I.leaf_blocks "STATS_BLOCKS"
		 from dba_segments S inner join dba_indexes I on
		      (S.owner=I.owner and S.segment_name=I.index_name)
		 where S.owner=upper('&1') and I.table_name not like 'BIN$%'
	 )
	 union all
	 (
		 select S.owner, S.segment_name, S.partition_name, L.table_name, S.segment_type, round(S.bytes/1024/1204, 1) mb, S.blocks, null "STATS_BLOCKS"
		 from dba_segments S inner join dba_lobs L on
		      (S.owner=L.owner and S.segment_name=L.segment_name)
		 where S.owner=upper('&1') and L.table_name not like 'BIN$%'
	 )
	 union all
	 (
		 select S.owner, S.segment_name, S.partition_name, T.table_name, S.segment_type, round(S.bytes/1024/1204, 1) mb, S.blocks, T.blocks "STATS_BLOCKS"
		 from dba_segments S inner join dba_tables T on
		      (S.owner=T.owner and S.segment_name=T.table_name)
		 where S.owner=upper('&1') and T.table_name not like 'BIN$%'
	 )
  ) F
order by F.owner, F.table_name, F.partition_name, F.mb desc, F.segment_type
/

select chr(10) || 'OWNER(Count(*));TABLE_NAME;Count;end@' from dual
/
select "OWNER" || ';' || "TABLE_NAME" || ';' || "Count"
from
(
	(select upper('&1') as "OWNER", 'CDM_ROOT_1' as "TABLE_NAME", count(*) "Count" from "&1".CDM_ROOT_1)
	union all
	(select upper('&1') as "OWNER", 'CDM_COMPOSITION_1' as "TABLE_NAME", count(*) "Count" from "&1".CDM_COMPOSITION_1)
	union all
	(select upper('&1') as "OWNER", 'CDM_PROCESS_1' as "TABLE_NAME", count(*) "Count" from "&1".CDM_PROCESS_1)
	union all
	(select upper('&1') as "OWNER", 'CDM_SQLBACKUP_1' as "TABLE_NAME", count(*) "Count" from "&1".CDM_SQLBACKUP_1)
	union all
	(select upper('&1') as "OWNER", 'CDM_INSTALLED_SOFTWARE_1' as "TABLE_NAME", count(*) "Count" from "&1".CDM_INSTALLED_SOFTWARE_1)
	union all
	(select upper('&1') as "OWNER", 'MANAGED_OBJECT_1' as "TABLE_NAME", count(*) "Count" from "&1".MANAGED_OBJECT_1)
	union all
	(select upper('&1') as "OWNER", 'MANAGED_RELATIONSHIP_1' as "TABLE_NAME", count(*) "Count" from "&1".MANAGED_RELATIONSHIP_1)
	union all
	(select upper('&1') as "OWNER", 'NODE_1' as "TABLE_NAME", count(*) "Count" from "&1".NODE_1)
	union all
	(select upper('&1') as "OWNER", 'CDM_NODE_1' as "TABLE_NAME", count(*) "Count" from "&1".CDM_NODE_1)
	union all
	(select upper('&1') as "OWNER", 'CONFIGURATION_ITEM_1' as "TABLE_NAME", count(*) "Count" from "&1".CONFIGURATION_ITEM_1)
	union all
	(select upper('&1') as "OWNER", 'IP_ADDRESS_1' as "TABLE_NAME", count(*) "Count" from "&1".IP_ADDRESS_1)
	union all
	(select upper('&1') as "OWNER", 'SHELL_1' as "TABLE_NAME", count(*) "Count" from "&1".SHELL_1)
	union all
	(select upper('&1') as "OWNER", 'PROCESS_1' as "TABLE_NAME", count(*) "Count" from "&1".PROCESS_1)
	union all
	(select upper('&1') as "OWNER", 'CCM_DISCOVERY_DESTS' as "TABLE_NAME", count(*) "Count" from "&1".CCM_DISCOVERY_DESTS)
	union all
	(select upper('&1') as "OWNER", 'CCM_DISCOVERY_DESTS(ID)' as "TABLE_NAME", count(*) "Count" from (select distinct ID from "&1".CCM_DISCOVERY_DESTS))
	union all
	(select upper('&1') as "OWNER", 'CCM_DISCOVERY_DESTS_RESULTS' as "TABLE_NAME", count(*) "Count" from "&1".CCM_DISCOVERY_DESTS_RESULTS)
	union all
	(select upper('&1') as "OWNER", 'CCM_DISCOVERY_ERRORS' as "TABLE_NAME", count(*) "Count" from "&1".CCM_DISCOVERY_ERRORS)
	union all
	(select upper('&1') as "OWNER", 'CCM_DISCOVERY_STATS' as "TABLE_NAME", count(*) "Count" from "&1".CCM_DISCOVERY_STATS)
	union all
	(select upper('&1') as "OWNER", 'CCM_DISCOVERY_DEST_IPS' as "TABLE_NAME", count(*) "Count" from "&1".CCM_DISCOVERY_DEST_IPS)
	union all
	(select upper('&1') as "OWNER", 'CCM_DISCOVERY_DEST_IPS(DISCOVERY_DESTS_ID)' as "TABLE_NAME", count(*) "Count" from (select distinct DISCOVERY_DESTS_ID from "&1".CCM_DISCOVERY_DEST_IPS))
	union all
	(select upper('&1') as "OWNER", 'CDM_LIST_ATTR_PRIMITIVE_1' as "TABLE_NAME", count(*) "Count" from "&1".CDM_LIST_ATTR_PRIMITIVE_1)
	union all
	(select upper('&1') as "OWNER", 'LOA' as "TABLE_NAME", count(*) "Count" from "&1".LOA)
	union all
	(select upper('&1') as "OWNER", 'HDM_ROOT_1' as "TABLE_NAME", count(*) "Count" from "&1".HDM_ROOT_1)
	union all
	(select upper('&1') as "OWNER", 'HDM_140610COMPOSITION_1' as "TABLE_NAME", count(*) "Count" from "&1".HDM_140610COMPOSITION_1)
	union all
	(select upper('&1') as "OWNER", 'HDM_140610CONTAINMENT_1' as "TABLE_NAME", count(*) "Count" from "&1".HDM_140610CONTAINMENT_1)
	union all
	(select upper('&1') as "OWNER", 'HDM_140710PROCESS_1' as "TABLE_NAME", count(*) "Count" from "&1".HDM_140710PROCESS_1)
	union all
	(select upper('&1') as "OWNER", 'HDM_140810SQLBACKUP_1' as "TABLE_NAME", count(*) "Count" from "&1".HDM_140810SQLBACKUP_1)
	union all
	(select upper('&1') as "OWNER", 'HDM_140810IP_ADDRESS_1' as "TABLE_NAME", count(*) "Count" from "&1".HDM_140810IP_ADDRESS_1)
)
/

--UCMDB 10.0
select chr(10) || '&1;Data;Object;Link;Total;end@' from dual
/
select '&1' || ';' || A.CNT || ';' || B.CNT || ';' || C.CNT || ';' || D.CNT
from
 (select count(*) CNT
 from "&1".cdm_root_1 R
 where a_root_class in
               (select CLASS_NAME
               from "&1".CLASS_MODEL_ENCODING
               where path like (select path || '%' from "&1".CLASS_MODEL_ENCODING where class_name in  ('data')))) A,
 (select count(*) CNT
 from "&1".cdm_root_1 R
 where a_root_class in
               (select CLASS_NAME
               from "&1".CLASS_MODEL_ENCODING
               where path like (select path || '%' from "&1".CLASS_MODEL_ENCODING where class_name in  ('object')))) B,
 (select count(*) CNT
 from "&1".cdm_root_1 R
 where a_root_class in
               (select CLASS_NAME
               from "&1".CLASS_MODEL_ENCODING
               where path like (select path || '%' from "&1".CLASS_MODEL_ENCODING where class_name in  ('link')))) C,
 (select count(*) CNT
 from "&1".cdm_root_1) D
/

select chr(10) || 'class_name;customer_id;path;table_by_class;view_by_class;level;parent_class_name;count;end@' from dual
/
select class_name || ';' || customer_id || ';' || path || ';' || table_by_class || ';' || view_by_class || ';' || "level" || ';' || "parent_class_name" || ';' || A.CNT
from 
   (select a_root_class, count(*) CNT
   from "&1".cdm_root_1
   group by a_root_class) A
      right outer join
	(select class_name,customer_id, path,table_by_class,view_by_class, length(path)/2 "level",
			(select class_name
	   			    from "&1".CLASS_MODEL_ENCODING P
	   			    where P.path=substr(C.path,1,length(C.path)-2)) "parent_class_name"
		   from "&1".CLASS_MODEL_ENCODING C
	) P 
		on (A.a_root_class=P.class_name)
order by "parent_class_name","level",path
/

select chr(10) || 'ID;CONFIG_ID;SCHEMA_TYPE;HOST_NAME;DB_NAME;DB_TYPE;SID;PORT;USER_NAME;PASSWORD;IS_GLOBAL;end@' from dual
/
select ID || ';' || CONFIG_ID || ';' || SCHEMA_TYPE || ';' || HOST_NAME || ';' || DB_NAME || ';' || DB_TYPE || ';' || SID || ';' || PORT || ';' || USER_NAME || ';' || PASSWORD || ';' || IS_GLOBAL 
from "&1".db_context
/

select chr(10) || 'OPERATION;TARGET;START_TIME;END_TIME;TimeDiff;end@'
from dual
/
select OPERATION || ';' || TARGET || ';' || to_char(start_time) || ';' || to_char(end_time) || ';' || (OO.end_time-OO.start_time)
from DBA_OPTSTAT_OPERATIONS OO 
where OO.start_time >= systimestamp-15 
	--to_date('11-JUL-2012 18:00:00','DD-MON-YYYY hh24:mi:ss') and to_date('02-AUG-2012 20:00:00','DD-MON-YYYY hh24:mi:ss')
	and lower(OPERATION) like 'gather@_%' escape '@'
order by OO.start_time
/


select '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++' || chr(10) from dual
/

select * from table(dbms_xplan.display_cursor('1b5p1c3xdqjsp', NULL,'ALLSTATS LAST ADVANCED ALL'))
/
select '===============================================' from dual
/
select * from table(dbms_xplan.display_awr('1b5p1c3xdqjsp', NULL, NULL, 'ALLSTATS LAST ADVANCED ALL'))
/

select '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++' || chr(10) from dual
/

select * from table(dbms_xplan.display_cursor('369n4t0tabzj6', NULL,'ALLSTATS LAST ADVANCED ALL'))
/
select '===============================================' from dual
/
select * from table(dbms_xplan.display_awr('369n4t0tabzj6', NULL, NULL, 'ALLSTATS LAST ADVANCED ALL'))
/

select '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++' || chr(10) from dual
/

select * from table(dbms_xplan.display_cursor('4a3ym0vr52r42', NULL,'ALLSTATS LAST ADVANCED ALL'))
/
select '===============================================' from dual
/
select * from table(dbms_xplan.display_awr('4a3ym0vr52r42', NULL, NULL, 'ALLSTATS LAST ADVANCED ALL'))
/

select '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++' || chr(10) from dual
/

select * from table(dbms_xplan.display_cursor('4wzjwdynz7u5n', NULL,'ALLSTATS LAST ADVANCED ALL'))
/
select '===============================================' from dual
/
select * from table(dbms_xplan.display_awr('4wzjwdynz7u5n', NULL, NULL, 'ALLSTATS LAST ADVANCED ALL'))
/

select '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++' || chr(10) from dual
/

select * from table(dbms_xplan.display_cursor('5w7sdhstqha2g', NULL,'ALLSTATS LAST ADVANCED ALL'))
/
select '===============================================' from dual
/
select * from table(dbms_xplan.display_awr('5w7sdhstqha2g', NULL, NULL, 'ALLSTATS LAST ADVANCED ALL'))
/

select '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++' || chr(10) from dual
/

select * from table(dbms_xplan.display_cursor('7bpu1k59mt7nc', NULL,'ALLSTATS LAST ADVANCED ALL'))
/
select '===============================================' from dual
/
select * from table(dbms_xplan.display_awr('7bpu1k59mt7nc', NULL, NULL, 'ALLSTATS LAST ADVANCED ALL'))
/

select '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++' || chr(10) from dual
/

select * from table(dbms_xplan.display_cursor('bbvh4fkbqtdcr', NULL,'ALLSTATS LAST ADVANCED ALL'))
/
select '===============================================' from dual
/
select * from table(dbms_xplan.display_awr('bbvh4fkbqtdcr', NULL, NULL, 'ALLSTATS LAST ADVANCED ALL'))
/

select '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++' || chr(10) from dual
/

select * from table(dbms_xplan.display_cursor('bw4jta0sfrnvg', NULL,'ALLSTATS LAST ADVANCED ALL'))
/
select '===============================================' from dual
/
select * from table(dbms_xplan.display_awr('bw4jta0sfrnvg', NULL, NULL, 'ALLSTATS LAST ADVANCED ALL'))
/

select '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++' || chr(10) from dual
/

select * from table(dbms_xplan.display_cursor('czkdd4baj2b8s', NULL,'ALLSTATS LAST ADVANCED ALL'))
/
select '===============================================' from dual
/
select * from table(dbms_xplan.display_awr('czkdd4baj2b8s', NULL, NULL, 'ALLSTATS LAST ADVANCED ALL'))
/

select '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++' || chr(10) from dual
/

select * from table(dbms_xplan.display_cursor('fndnmday3fs2u', NULL,'ALLSTATS LAST ADVANCED ALL'))
/
select '===============================================' from dual
/
select * from table(dbms_xplan.display_awr('fndnmday3fs2u', NULL, NULL, 'ALLSTATS LAST ADVANCED ALL'))
/

select '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++' || chr(10) from dual
/

select * from table(dbms_xplan.display_cursor('g1md57ghhwdhz', NULL,'ALLSTATS LAST ADVANCED ALL'))
/
select '===============================================' from dual
/
select * from table(dbms_xplan.display_awr('g1md57ghhwdhz', NULL, NULL, 'ALLSTATS LAST ADVANCED ALL'))
/

select '++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++' || chr(10) from dual
/


spool off

set heading on
set serveroutput on
set feedback on
set SHOW on
set VERIFY on
set pagesize 100
